"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChangePasswordDialog = void 0;
var react_1 = __importStar(require("react"));
var constants_1 = require("../../constants");
var contexts_1 = require("../../contexts");
var hooks_1 = require("../../hooks");
var ChangePasswordDialogBase_1 = require("./ChangePasswordDialogBase");
/**
 * Component that renders a dialog with textField to enter current password and a change password form with a new password and confirm password inputs.
 * It includes callbacks so you can respond to changes in the inputs.
 *
 * @param dialogTitle title to display in the dialog
 * @param dialogDescription description to display in the dialog
 * @param currentPasswordLabel label to display for the current password field
 * @param previousLabel label to display for the previous button
 * @param nextLabel label to display for the next button
 * @param currentPasswordChange called when the current password field changes
 * @param enableButton boolean to enable and disable the button
 * @param onSubmit Callback function to call when the form is submitted
 *
 * @category Component
 */
var ChangePasswordDialog = function (props) {
    var t = (0, hooks_1.useLanguageLocale)().t;
    var passwordRef = (0, react_1.useRef)(null);
    var confirmRef = (0, react_1.useRef)(null);
    var _a = (0, react_1.useState)(''), currentInput = _a[0], setCurrentInput = _a[1];
    var _b = (0, react_1.useState)(''), passwordInput = _b[0], setPasswordInput = _b[1];
    var _c = (0, react_1.useState)(''), confirmInput = _c[0], setConfirmInput = _c[1];
    var _d = (0, react_1.useState)(false), showErrorDialog = _d[0], setShowErrorDialog = _d[1];
    var _e = (0, react_1.useState)(false), isLoading = _e[0], setIsLoading = _e[1];
    var _f = (0, contexts_1.useAuthContext)(), actions = _f.actions, navigate = _f.navigate, routeConfig = _f.routeConfig;
    var open = props.open, _g = props.dialogTitle, dialogTitle = _g === void 0 ? t('bluiAuth:CHANGE_PASSWORD.PASSWORD') : _g, _h = props.dialogDescription, dialogDescription = _h === void 0 ? t('bluiAuth:CHANGE_PASSWORD.PASSWORD_INFO') : _h, _j = props.currentPasswordLabel, currentPasswordLabel = _j === void 0 ? t('bluiCommon:LABELS.CURRENT_PASSWORD') : _j, _k = props.previousLabel, previousLabel = _k === void 0 ? t('bluiCommon:ACTIONS.BACK') : _k, _l = props.nextLabel, nextLabel = _l === void 0 ? t('bluiCommon:ACTIONS.OKAY') : _l, onPrevious = props.onPrevious, onSubmit = props.onSubmit, PasswordProps = props.PasswordProps, ErrorDialogProps = props.ErrorDialogProps;
    var passwordRequirements = (0, constants_1.defaultPasswordRequirements)(t);
    var updateFields = (0, react_1.useCallback)(function (fields) {
        setPasswordInput(fields.password);
        setConfirmInput(fields.confirm);
    }, [setPasswordInput, setConfirmInput]);
    var checkPasswords = currentInput !== '' && passwordInput !== '' && confirmInput !== '' && passwordInput === confirmInput;
    var changePasswordSubmit = (0, react_1.useCallback)(function () { return __awaiter(void 0, void 0, void 0, function () {
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (!checkPasswords) return [3 /*break*/, 5];
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 3, 4, 5]);
                    setIsLoading(true);
                    return [4 /*yield*/, actions.changePassword(currentInput, passwordInput)];
                case 2:
                    _b.sent();
                    onSubmit();
                    return [3 /*break*/, 5];
                case 3:
                    _a = _b.sent();
                    setShowErrorDialog(true);
                    return [3 /*break*/, 5];
                case 4:
                    setIsLoading(false);
                    return [7 /*endfinally*/];
                case 5: return [2 /*return*/];
            }
        });
    }); }, [checkPasswords, currentInput, passwordInput, actions, setIsLoading, setShowErrorDialog, onSubmit]);
    var passwordProps = __assign(__assign({ newPasswordLabel: t('bluiAuth:CHANGE_PASSWORD.NEW_PASSWORD'), confirmPasswordLabel: t('bluiAuth:CHANGE_PASSWORD.CONFIRM_NEW_PASSWORD'), passwordRef: passwordRef, confirmRef: confirmRef, initialNewPasswordValue: passwordInput, initialConfirmPasswordValue: confirmInput, passwordRequirements: passwordRequirements, passwordNotMatchError: t('bluiCommon:FORMS.PASS_MATCH_ERROR') }, PasswordProps), { onPasswordChange: function (passwordData) {
            var _a;
            updateFields(passwordData);
            (_a = PasswordProps === null || PasswordProps === void 0 ? void 0 : PasswordProps.onPasswordChange) === null || _a === void 0 ? void 0 : _a.call(PasswordProps, passwordData);
        }, onSubmit: function () {
            var _a;
            void changePasswordSubmit();
            (_a = PasswordProps === null || PasswordProps === void 0 ? void 0 : PasswordProps.onSubmit) === null || _a === void 0 ? void 0 : _a.call(PasswordProps);
        } });
    var errorDialogProps = __assign(__assign({ open: showErrorDialog, title: t('bluiCommon:MESSAGES.ERROR'), body: t('bluiAuth:CHANGE_PASSWORD.PROBLEM_OCCURRED'), dismissButtonText: t('bluiCommon:ACTIONS.OKAY') }, ErrorDialogProps), { onClose: function () { return setShowErrorDialog(false); } });
    return (react_1.default.createElement(ChangePasswordDialogBase_1.ChangePasswordDialogBase, { open: open, loading: isLoading, dialogTitle: dialogTitle, dialogDescription: dialogDescription, currentPasswordLabel: currentPasswordLabel, previousLabel: previousLabel, nextLabel: nextLabel, currentPasswordChange: function (currentPwd) { return setCurrentInput(currentPwd); }, enableButton: checkPasswords, onPrevious: onPrevious, onSubmit: function () {
            void changePasswordSubmit();
            navigate(routeConfig.LOGIN);
        }, PasswordProps: passwordProps, ErrorDialogProps: errorDialogProps }));
};
exports.ChangePasswordDialog = ChangePasswordDialog;
