"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RegistrationWorkflow = void 0;
var react_1 = __importStar(require("react"));
var contexts_1 = require("../../contexts");
var screens_1 = require("../../screens");
var utils_1 = require("../../utils");
var useErrorManager_1 = require("../../contexts/ErrorContext/useErrorManager");
var ErrorManager_1 = __importDefault(require("../Error/ErrorManager"));
var RegistrationWorkflow = function (props) {
    var _a = (0, react_1.useState)(false), isAccountExist = _a[0], setIsAccountExist = _a[1];
    var _b = (0, useErrorManager_1.useErrorManager)(), triggerError = _b.triggerError, errorManagerConfig = _b.errorManagerConfig;
    var errorDisplayConfig = __assign(__assign(__assign({}, errorManagerConfig), props.errorDisplayConfig), { onClose: function () {
            if (props.errorDisplayConfig && props.errorDisplayConfig.onClose)
                props.errorDisplayConfig.onClose();
            if (errorManagerConfig.onClose)
                errorManagerConfig === null || errorManagerConfig === void 0 ? void 0 : errorManagerConfig.onClose();
        } });
    var _c = props.initialScreenIndex, initialScreenIndex = _c === void 0 ? 0 : _c, _d = props.successScreen, successScreen = _d === void 0 ? react_1.default.createElement(screens_1.RegistrationSuccessScreen, null) : _d, _e = props.existingAccountSuccessScreen, existingAccountSuccessScreen = _e === void 0 ? react_1.default.createElement(screens_1.ExistingAccountSuccessScreen, null) : _e, _f = props.isInviteRegistration, isInviteRegistration = _f === void 0 ? false : _f, _g = props.children, children = _g === void 0 ? isInviteRegistration
        ? [
            react_1.default.createElement(screens_1.EulaScreen, { key: "EulaScreen" }),
            react_1.default.createElement(screens_1.CreatePasswordScreen, { key: "CreatePasswordScreen" }),
            react_1.default.createElement(screens_1.AccountDetailsScreen, { key: "AccountDetailsScreen" }),
        ]
        : [
            react_1.default.createElement(screens_1.EulaScreen, { key: "EulaScreen" }),
            react_1.default.createElement(screens_1.CreateAccountScreen, { key: "CreateAccountScreen" }),
            react_1.default.createElement(screens_1.VerifyCodeScreen, { key: "VerifyCodeScreen" }),
            react_1.default.createElement(screens_1.CreatePasswordScreen, { key: "CreatePasswordScreen" }),
            react_1.default.createElement(screens_1.AccountDetailsScreen, { key: "AccountDetailsScreen" }),
        ] : _g;
    var screens = __spreadArray([], (Array.isArray(children) ? children : [children]), true);
    var totalScreens = screens.length;
    var _h = (0, react_1.useState)(initialScreenIndex < 0 ? 0 : initialScreenIndex > totalScreens - 1 ? totalScreens - 1 : initialScreenIndex), currentScreen = _h[0], setCurrentScreen = _h[1];
    var _j = (0, react_1.useState)(false), showSuccessScreen = _j[0], setShowSuccessScreen = _j[1];
    var _k = (0, contexts_1.useRegistrationContext)(), actions = _k.actions, navigate = _k.navigate;
    var _l = (0, react_1.useState)({
        Eula: {
            accepted: false,
        },
        CreateAccount: {
            emailAddress: '',
        },
        VerifyCode: {
            code: '',
            isAccountExist: false,
        },
        CreatePassword: {
            password: '',
            confirmPassword: '',
        },
        AccountDetails: {
            firstName: '',
            lastName: '',
        },
        Other: {},
    }), screenData = _l[0], setScreenData = _l[1];
    var updateScreenData = function (data) {
        var Other = screenData.Other;
        var screenId = data.screenId, values = data.values;
        if (!Object.keys(screenData).includes(screenId)) {
            setScreenData(function (oldData) {
                var _a;
                return (__assign(__assign({}, oldData), { Other: __assign(__assign({}, oldData.Other), (_a = {}, _a[screenId] = values, _a)) }));
            });
        }
        else if (Object.keys(Other).includes(screenId)) {
            setScreenData(function (oldData) {
                var _a;
                return (__assign(__assign({}, oldData), { Other: __assign(__assign({}, Other), (_a = {}, _a[screenId] = __assign(__assign({}, Other[screenId]), values), _a)) }));
            });
        }
        else {
            setScreenData(function (oldData) {
                var _a;
                return (__assign(__assign({}, oldData), (_a = {}, _a[screenId] = values, _a)));
            });
        }
    };
    var finishRegistration = function (data) {
        if (actions && actions.completeRegistration) {
            var Eula = screenData.Eula, CreateAccount = screenData.CreateAccount, VerifyCode = screenData.VerifyCode, CreatePassword = screenData.CreatePassword, AccountDetails = screenData.AccountDetails, Other = screenData.Other;
            var userInfo = __assign(__assign(__assign(__assign(__assign(__assign(__assign({}, Eula), CreateAccount), VerifyCode), CreatePassword), AccountDetails), Other), data.values);
            return actions
                .completeRegistration(userInfo)
                .then(function (_a) {
                var email = _a.email, organizationName = _a.organizationName;
                updateScreenData({
                    screenId: 'RegistrationSuccessScreen',
                    values: { email: email, organizationName: organizationName },
                });
                setShowSuccessScreen(true);
            })
                .catch(function (_error) {
                triggerError(_error);
            });
        }
    };
    (0, react_1.useEffect)(function () {
        if (isInviteRegistration) {
            var params = (0, utils_1.parseQueryString)(window.location.search);
            updateScreenData({ screenId: 'CreateAccount', values: { emailAddress: params.email } });
            updateScreenData({ screenId: 'VerifyCode', values: { code: params.code } });
        }
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    return (react_1.default.createElement(contexts_1.RegistrationWorkflowContextProvider, { currentScreen: currentScreen, totalScreens: totalScreens, nextScreen: function (data) {
            updateScreenData(data);
            if (data.isAccountExist) {
                setIsAccountExist(true);
                setShowSuccessScreen(true);
            }
            if (currentScreen === totalScreens - 1)
                return finishRegistration(data);
            setCurrentScreen(function (i) { return i + 1; });
        }, previousScreen: function (data) {
            updateScreenData(data);
            if (currentScreen === 0) {
                navigate(-1);
            }
            setCurrentScreen(function (i) { return i - 1; });
        }, screenData: screenData, updateScreenData: updateScreenData, isInviteRegistration: isInviteRegistration },
        react_1.default.createElement(ErrorManager_1.default, __assign({}, errorDisplayConfig, { mode: "dialog" }), showSuccessScreen
            ? isAccountExist
                ? existingAccountSuccessScreen
                : successScreen
            : screens[currentScreen])));
};
exports.RegistrationWorkflow = RegistrationWorkflow;
