/// <reference types="react" />
import { ErrorManagerProps } from '../../components/Error';
import { WorkflowCardProps } from '../../components/WorkflowCard/WorkflowCard.types';
import { SuccessScreenProps } from '../SuccessScreen';
export type ForgotPasswordScreenProps = WorkflowCardProps & {
    contactPhone?: string;
    responseTime?: string;
    description?: (responseTime: string) => React.ReactNode;
    title?: string;
    showBackButton?: boolean;
    backButtonLabel?: string;
    canGoBack?: boolean | (() => boolean);
    showNextButton?: boolean;
    nextButtonLabel?: string;
    canGoNext?: boolean | (() => boolean);
    /**
     * The label for the email field
     */
    emailLabel?: string;
    /**
     * The initial value for the email text field
     */
    initialEmailValue?: string;
    /**
     * A function used to test the input for valid formatting
     * @param {string} email - the provided email address
     * @returns boolean | string
     */
    emailValidator?: (email: string) => boolean | string;
    /**
     * Used for ForgotPasswordScreen SuccessScreen
     */
    slots?: {
        SuccessScreen?: (props: SuccessScreenProps) => JSX.Element;
    };
    /**
     * Applied to slot from SuccessScreen
     */
    slotProps?: {
        SuccessScreen?: SuccessScreenProps;
    };
    /**
     * Used to determine whether to show a success screen after the form is submitted
     */
    showSuccessScreen?: boolean;
    /**
     * The configuration for customizing how errors are displayed
     */
    errorDisplayConfig?: ErrorManagerProps;
};
